<?php
/**
 * Open Source Social Network
 *
 * @package   Open Source Social Network
 * @author    Open Social Website Core Team <info@openteknik.com>
 * @copyright 2021 OPEN TEKNIK 
 * @license   OPEN SOURCE SOCIAL NETWORK LICENSE 4.0
 * @link      http://www.opensource-socialnetwork.org/licence
 */
require_once(AzureADLogin . 'vendors/oauthad/vendor/autoload.php');

$component = new OssnComponents;
$settings  = $component->getSettings('AzureADLogin'); 
 
$provider = new \TheNetworg\OAuth2\Client\Provider\Azure([
    'clientId'          => $settings->client_id,
    'clientSecret'      => $settings->client_secret,
    'redirectUri'       => ossn_site_url('azuread_login'),
]);

// Set to use v2 API, skip the line or set the value to Azure::ENDPOINT_VERSION_1_0 if willing to use v1 API
$provider->defaultEndPointVersion = TheNetworg\OAuth2\Client\Provider\Azure::ENDPOINT_VERSION_2_0;

$baseGraphUri = $provider->getRootMicrosoftGraphUri(null);
$provider->scope = 'openid profile email offline_access ' . $baseGraphUri . '/User.Read';
$authorizationUrl = $provider->getAuthorizationUrl(['scope' => $provider->scope]);
if($authorizationUrl && !empty($authorizationUrl)){
	header("Location: {$authorizationUrl}");
	exit;
} else {
	ossn_trigger_message(ossn_print('azureadlogin:apiurl:failed'), 'error');
	redirect(REF);	
}